class MissingKeywordsInDictionary(Exception):
    def __init__(self, missing_variable="ERROR_NOT_SPECIFIED", total_variable_list=("ERROR_NOT_SPECIFIED",)):
        self.message = f"Missing {missing_variable} in dictionary. Reminder of values that must be: {str(total_variable_list)}."
        super().__init__(self.message)


class MissingReplaceableLabels(Exception):
    def __init__(self, file):
        self.message = f"Missing any replaceable values. Check your template section in {file}!"
        super().__init__(self.message)


class DifferentReplaceableLabels(Exception):
    def __init__(self, tuple_of_labels1, tuple_of_labels2):
        self.message = "Replaceable value labels differ between API and Workflow versions. "
        self.message += f"One have {str(tuple_of_labels1)}, other have {str(tuple_of_labels2)}. Check your template section!"
        super().__init__(self.message)


class WrongWorkflowProvided(Exception):
    def __init__(self, got_type):
        self.message = f"Wrong workflow provided! Expected JSON-object Dict, but got {got_type}!"
        super().__init__(self.message)


class NoTemplateProvided(Exception):
    def __init__(self, path):
        self.message = f"No template was provided for path {path}!"
        super().__init__(self.message)


class TemplateProvidedDoesntExist(Exception):
    def __init__(self, generation_path, provided_notexistant_path):
        self.message = f"Template provided for path {generation_path} is absent. Please ensure that {provided_notexistant_path} exists!"
        super().__init__(self.message)
